Package net.shibboleth.idp.authn.revocation.impl

# Class DoRevocationCacheOperation

java.lang.Object
net.shibboleth.shared.component.AbstractInitializableComponent
org.opensaml.profile.action.AbstractProfileAction
org.opensaml.profile.action.AbstractConditionalProfileAction
net.shibboleth.idp.profile.AbstractProfileAction
net.shibboleth.idp.authn.revocation.impl.DoRevocationCacheOperation

All Implemented Interfaces:
  `Component`, `DestructableComponent`, `InitializableComponent`, `ProfileAction`, `Aware`, `MessageSource`, `MessageSourceAware`, `Action`

public class DoRevocationCacheOperation extends AbstractProfileAction
Action that implements a JSON REST API for the `RevocationCache` interface.

The API supports GET, PUT/POST, and DELETE at the moment, using jsonapi.org conventions.

GET
  Return a revocation record.
PUT/POST
  Insert or update a revocation record.
DELETE
  Delete revocation record.

Event:
  `EventIds.PROCEED_EVENT_ID`, `EventIds.INVALID_PROFILE_CTX`, `EventIds.IO_ERROR`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`CACHE_ID`
Flow variable indicating ID of cache bean to access.
`private String`
`cacheId`
Revocation Cache ID.
`private String`
`context`
Revocation context to operate on.
`static final String`
`CONTEXT`
Flow variable indicating ID of account context.
`private String`
`key`
Revocation key to operate on.
`static final String`
`KEY`
Flow variable indicating ID of account key.
`private org.slf4j.Logger`
`log`
Class logger.
`private com.fasterxml.jackson.databind.ObjectMapper`
`objectMapper`
JSON object mapper.
`private RevocationCache`
`revocationCache`
`RevocationCache` to operate on.

## Constructor Summary

Constructors
Constructor
Description
`DoRevocationCacheOperation()`

## Method Summary

Modifier and Type
Method
Description
`private void`
`doDelete()`
Delete a revocation record.
`protected void`
`doExecute(ProfileRequestContext profileRequestContext)`
`private void`
`doGet()`
Get a revocation record.
`protected void`
`doInitialize()`
`private void`
`doPost()`
Insert a revocation record.
`protected boolean`
`doPreExecute(ProfileRequestContext profileRequestContext)`
`private String`
`getCacheId()`
Null safe getter.
`private String`
`getContext()`
Null safe getter.
`private String`
`getKey()`
Null safe getter.
`private RevocationCache`
`getRevocationCache()`
Null safe getter.
`private void`
`sendError(int status, String title, String detail)`
Output an error object.
`void`
`setObjectMapper(com.fasterxml.jackson.databind.ObjectMapper mapper)`
Set the JSON `ObjectMapper` to use for serialization.

### Methods inherited from class net.shibboleth.idp.profile.AbstractProfileAction

`doExecute, execute, getBean, getBean, getMessage, getMessage, getMessage, getParameter, getParameter, getProfileContextLookupStrategy, getRequestContext, getResult, setMessageSource, setProfileContextLookupStrategy`

### Methods inherited from class org.opensaml.profile.action.AbstractConditionalProfileAction

`getActivationCondition, setActivationCondition`

### Methods inherited from class org.opensaml.profile.action.AbstractProfileAction

`doPostExecute, doPostExecute, ensureHttpServletRequest, ensureHttpServletResponse, execute, getHttpServletRequest, getHttpServletRequestSupplier, getHttpServletResponse, getHttpServletResponseSupplier, getLogPrefix, isPreExecuteCalled, setHttpServletRequestSupplier, setHttpServletResponseSupplier`

### Methods inherited from class net.shibboleth.shared.component.AbstractInitializableComponent

`checkComponentActive, checkSetterPreconditions, destroy, doDestroy, ifDestroyedThrowDestroyedComponentException, ifInitializedThrowUnmodifiabledComponentException, ifNotInitializedThrowUninitializedComponentException, initialize, isDestroyed, isInitialized`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface net.shibboleth.shared.component.InitializableComponent

`initialize, isInitialized`

## Field Details

### CACHE_ID

@Nonnull @NotEmpty public static final String CACHE_ID
Flow variable indicating ID of cache bean to access.

See Also:
  - Constant Field Values

### CONTEXT

@Nonnull @NotEmpty public static final String CONTEXT
Flow variable indicating ID of account context.

See Also:
  - Constant Field Values

### KEY

@Nonnull @NotEmpty public static final String KEY
Flow variable indicating ID of account key.

See Also:
  - Constant Field Values

### log

@Nonnull private org.slf4j.Logger log
Class logger.

### objectMapper

@NonnullAfterInit private com.fasterxml.jackson.databind.ObjectMapper objectMapper
JSON object mapper.

### cacheId

@NonnullBeforeExec @NotEmpty private String cacheId
Revocation Cache ID.

### context

@NonnullBeforeExec @NotEmpty private String context
Revocation context to operate on.

### key

@NonnullBeforeExec @NotEmpty private String key
Revocation key to operate on.

### revocationCache

@NonnullBeforeExec private RevocationCache revocationCache
`RevocationCache` to operate on.

## Constructor Details

### DoRevocationCacheOperation

public DoRevocationCacheOperation()

## Method Details

### setObjectMapper

public void setObjectMapper(@Nonnull com.fasterxml.jackson.databind.ObjectMapper mapper)
Set the JSON `ObjectMapper` to use for serialization.

Parameters:
  `mapper` - object mapper

### getRevocationCache

@Nonnull private RevocationCache getRevocationCache()
Null safe getter.

Returns:
  Returns the revocationCache.

### getCacheId

@Nonnull private String getCacheId()
Null safe getter.

Returns:
  Returns the cacheId.

### getKey

@Nonnull private String getKey()
Null safe getter.

Returns:
  Returns the key.

### getContext

@Nonnull private String getContext()
Null safe getter.

Returns:
  Returns the context.

### doInitialize

protected void doInitialize() throws ComponentInitializationException

Overrides:
  `doInitialize` in class `AbstractInitializableComponent`
Throws:
  `ComponentInitializationException`

### doPreExecute

protected boolean doPreExecute(@Nonnull ProfileRequestContext profileRequestContext)

Overrides:
  `doPreExecute` in class `AbstractConditionalProfileAction`

### doExecute

protected void doExecute(@Nonnull ProfileRequestContext profileRequestContext)

Overrides:
  `doExecute` in class `AbstractProfileAction`

### doGet

private void doGet() throws IOException
Get a revocation record.

Throws:
  `IOException` - if an I/O error occurs

### doPost

private void doPost() throws IOException
Insert a revocation record.

Throws:
  `IOException` - if an I/O error occurs

### doDelete

private void doDelete() throws IOException
Delete a revocation record.

Throws:
  `IOException` - if an I/O error occurs

### sendError

private void sendError(int status, @Nonnull @NotEmpty String title, @Nonnull @NotEmpty String detail) throws IOException
Output an error object.

Parameters:
  `status` - HTTP status
  `title` - fixed error description
  `detail` - human-readable error description
Throws:
  `IOException` - if unable to output the error